%
% logl.m, 04 Mar 2009 17:59 (+0100)
%
% Author: Pouya D. Tafti
%         Biomedical Imaging Group <http://bigwww.epfl.ch/>
%         Ecole Polytechnique Federale de Lausanne (EPFL)
%
% You are free to use this software for research purposes.  Redistribution
% without the consent of the Biomedical Imaging Group is not permitted.  This
% software is provided "AS IS" and any and all warranties, either express or
% implied, are hereby disclaimed.  In no event shall the EPFL or the developers
% be liable for any direct, indirect, incidental, special, exemplary,
% consequential, or other damages arising in any way out of the use of this
% software.
% 
% If you use this software in your research please consider citing the following
% reference(s).
% 
% [1] P. D. Tafti, D. Van De Ville, and M. Unser, "Invariances, Laplacian-like
%     wavelet bases, and the whitening of fractal processes", IEEE Transactions
%     on Image Processing, v. 18, no. 4, Apr. 2009.
% 
% [2] D. Van De Ville, T. Blu, M. Unser, "Isotropic Polyharmonic B-Splines:
%     Scaling Functions and Wavelets", IEEE Transactions on Image Processing,
%     vol.  14, no. 11, pp. 1798-1813, Nov. 2005.
%


function l = logl(svar,Nj,selectsubbands,Cp,Hp)

d    = 2;
detD = 2;

svar = svar(selectsubbands);
Nj   = Nj(selectsubbands);

svar = svar.*Nj; % we don't want the mean, but the energy!


l = zeros(length(Cp),length(Hp));
i = 0;
j = 0;
for ii = 1:length(Cp),
for jj = 1:length(Hp), 
    C = Cp(ii); H = Hp(jj);
    l(ii,jj) = .5*sum(log(C)*Nj + (log(detD)/d)*(2*H+d)*selectsubbands.*Nj+svar./(C*detD.^(selectsubbands*(2*H/d+1))));
end;
end;
