%
% wcoefmeansq.m, 04 Mar 2009 15:10 (+0100)
%
% Author: D. Van De Ville
%         Biomedical Imaging Group <http://bigwww.epfl.ch/>
%         Ecole Polytechnique Federale de Lausanne (EPFL)
%
% You are free to use this software for research purposes.  Redistribution
% without the consent of the Biomedical Imaging Group is not permitted.  This
% software is provided "AS IS" and any and all warranties, either express or
% implied, are hereby disclaimed.  In no event shall the EPFL or the developers
% be liable for any direct, indirect, incidental, special, exemplary,
% consequential, or other damages arising in any way out of the use of this
% software.
% 
% If you use this software in your research please consider citing the following
% reference(s).
% 
% [1] P. D. Tafti, D. Van De Ville, and M. Unser, "Invariances, Laplacian-like
%     wavelet bases, and the whitening of fractal processes", IEEE Transactions
%     on Image Processing, v. 18, no. 4, Apr. 2009.
% 
% [2] D. Van De Ville, T. Blu, M. Unser, "Isotropic Polyharmonic B-Splines:
%     Scaling Functions and Wavelets", IEEE Transactions on Image Processing,
%     vol.  14, no. 11, pp. 1798-1813, Nov. 2005.
%


function [svar Nj] = wcoefmeansq(A,J)

load poly_q_o_4_0_512x512;

Q1=bf_FFTquin2D_analysis(A,J,FA);

xl=1; xh=size(Q1,1);
yl=size(Q1,2)/2+1; yh=size(Q1,2);

clear sub;

Nj = zeros(1,J);

for iter=1:J,
   sub{iter}=Q1(xl:xh,yl:yh);
   tmp=sub{iter};
   tmp=tmp-min(tmp(:));
   tmp=tmp/max(abs(tmp(:)));
   Q1(xl:xh,yl:yh)=tmp;
   if mod(iter,2)==1,
       Q1(xl:xh,yl)=1;
       xl=xh/2+1;
       yh=yl-1;
       yl=1;
   else
       Q1(xl,yl:yh)=1;
       xh=xh/2;
       xl=1;
       yl=yh/2+1;
   end;
   
end;

clear svar svarj;
svar=zeros(1,J);

for iter=1:J,
    svar(iter)=mean(abs(sub{iter}(:)).^2);
    Nj(iter) = length(sub{iter}(:));
    svarj(iter)=-iter;
end;
